'use strict';

module.exports = {
  description: 'Blueprint for @choiceform/ui-foundation',

  normalizeEntityName(entityName) {
    return entityName;
  },

  afterInstall: function(options) {
    const isAddon = options.project.isEmberCLIAddon();

    const targetName = isAddon ? 'addon' : 'app';
    this.ui.writeInfoLine(`Installing dependencies for ${targetName} ...`);
    this.ui.writeInfoLine(`正在为 ${targetName} 安装依赖...`);

    const blueprintOptions = { save: isAddon };
    return (
      this.addAddonToProject({ name: 'ember-auto-import', blueprintOptions })
        .then(() =>
          this.addAddonToProject({
            name: 'ember-cli-autoprefixer',
            blueprintOptions,
          })
        )
        .then(() =>
          this.addAddonToProject({
            name: 'ember-css-modules',
            blueprintOptions,
          })
        )
        .then(() =>
          this.addAddonToProject({ name: 'ember-lifeline', blueprintOptions })
        )
        .then(() => this.addAddonToProject({ name: 'ember-decorators' }))
        .then(() => this.addAddonToProject({ name: 'ember-qunit-decorators' }))
        .then(() => this.addPackageToProject('@types/ember'))
        .then(() => this.addPackageToProject('@types/ember-qunit'))
        .then(() => this.addPackageToProject('@types/ember-test-helpers'))
        .then(() => this.addPackageToProject('@types/ember-testing-helpers'))
        .then(() => this.addPackageToProject('@types/ember__test-helpers'))
        .then(() => this.addPackageToProject('@types/qunit'))
        .then(() => this.addPackageToProject('@types/qunit-dom'))
        .then(() => this.addPackageToProject('@types/rsvp'))
        .then(() => this.addPackageToProject('eslint-plugin-qunit'))
        // .then(() => this.addPackageToProject('@typescript-eslint/parser'))
        // .then(() => this.addPackageToProject('@typescript-eslint/eslint-plugin'))
        .then(() => {
          this.ui.writeLine(`For ${targetName} usage, please run:`);
          this.ui.writeLine(`用于 ${targetName}，请运行：`);
          this.ui.writeInfoLine(`ember generate foundation-for-${targetName}`);
        })
    );
  },
};
